#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

const long MAX_TIME = 2000; //1440 ?
const long INFINITY = 1000000;

long cMachinesByTime[MAX_TIME];
long maxMachinesTransported[MAX_TIME];
long minTravels[MAX_TIME];

int main()
{
#ifndef ONLINE_JUDGE
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#endif

	long cTests, iTest;
	scanf("%ld", &cTests);

	for(iTest = 0; iTest < cTests; ++iTest)
	{
		long capacity, speed, cMachines;
		scanf("%ld %ld %ld", &capacity, &speed, &cMachines);

		long time, oldTime, newTime, iMachine;

		oldTime = 0;
		for(iMachine = 0; iMachine < cMachines; ++iMachine)
		{
			scanf("%ld", &newTime);
			for(time = oldTime; time < newTime; ++time)
				cMachinesByTime[time] = iMachine;
		}
		for(; time < MAX_TIME; ++time)
			cMachinesByTime[time] = iMachine;

		for(time = 0; time < MAX_TIME; ++time)
		{
			maxMachinesTransported[time] = 0;
			minTravels[time] = 0;
			for(oldTime = 0; oldTime <= time - 2 * speed; ++oldTime)
			{
				static long transported;
				transported = maxMachinesTransported[oldTime] + capacity;
				if(transported > cMachinesByTime[oldTime])
					transported = cMachinesByTime[oldTime];
				if(transported >= maxMachinesTransported[time])
				{
					if(transported > maxMachinesTransported[time])
						minTravels[time] = minTravels[oldTime] + 1;
					else
						if(minTravels[time] > minTravels[oldTime] + 1)
							minTravels[time] = minTravels[oldTime] + 1;
					maxMachinesTransported[time] = transported;
				}
			}
		}

		for(time = 0; time < MAX_TIME; ++time)
			if(maxMachinesTransported[time] == cMachines)break;

		printf("%ld %ld\n", time - speed, minTravels[time]);

	}

#ifndef ONLINE_JUDGE
	fclose(stdin);
	fclose(stdout);
#endif
	return 0;
}